Package org.jbpm.services.ejb.api

## Interface DeploymentServiceEJBRemote

- All Known Implementing Classes:
    `DeploymentServiceEJBImpl`

      public interface DeploymentServiceEJBRemote

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `activate​(String deploymentId)` | Activates given deployment by making sure it will be available for execution.
    `void` | `deactivate​(String deploymentId)` | Deactivates given deployment by making it only available for already running instances.
    `void` | `deploy​(String groupId, String artifactId, String version)` | Deploys artifact identified by given GAV (group, artifact, version)
    `void` | `deploy​(String groupId, String artifactId, String version, String kbaseName, String ksessionName)` | Deploys artifact identified by given GAV (group, artifact, version) with additional selection of kbase and ksession names from kmodule.xml - these names must exists in kmodule.xml of the artifact being deployed
    `void` | `deploy​(String groupId, String artifactId, String version, String kbaseName, String ksessionName, String strategy)` | Deploys artifact identified by given GAV (group, artifact, version) with additional selection of kbase and ksession names from kmodule.xml - these names must exists in kmodule.xml of the artifact being deployed and runtime strategy (singleton, per request, per process instance)
    `boolean` | `isDeployed​(String deploymentUnitId)` | Performs a check if given deployment is already active
    `void` | `undeploy​(String deploymentId)` | Undeploys currently active deployment unit identified by given deploymentId
    `void` | `undeploy​(String deploymentId, Function<DeploymentUnit,​Boolean> beforeUndeploy)` | Undeploys currently active deployment unit identified by given deploymentId

- - ### Method Detail

    - #### deploy

          void deploy​(String groupId,
                      String artifactId,
                      String version)

      Deploys artifact identified by given GAV (group, artifact, version)
      Parameters:
        `groupId` - group id of the artifact to deploy
        `artifactId` - artifact id of the artifact to deploy
        `version` - version of the artifact to deploy

    - #### deploy

          void deploy​(String groupId,
                      String artifactId,
                      String version,
                      String kbaseName,
                      String ksessionName)

      Deploys artifact identified by given GAV (group, artifact, version) with additional selection of kbase and ksession names from kmodule.xml - these names must exists in kmodule.xml of the artifact being deployed
      Parameters:
        `groupId` - group id of the artifact to deploy
        `artifactId` - artifact id of the artifact to deploy
        `version` - version of the artifact to deploy
        `kbaseName` - name of kie base defined in kmodule.xml
        `ksessionName` - name of kie session defined in kmodule.xml

    - #### deploy

          void deploy​(String groupId,
                      String artifactId,
                      String version,
                      String kbaseName,
                      String ksessionName,
                      String strategy)

      Deploys artifact identified by given GAV (group, artifact, version) with additional selection of kbase and ksession names from kmodule.xml - these names must exists in kmodule.xml of the artifact being deployed and runtime strategy (singleton, per request, per process instance)
      Parameters:
        `groupId` - group id of the artifact to deploy
        `artifactId` - artifact id of the artifact to deploy
        `version` - version of the artifact to deploy
        `kbaseName` - name of kie base defined in kmodule.xml
        `ksessionName` - name of kie session defined in kmodule.xml
        `strategy` - selected runtime strategy

    - #### undeploy

          void undeploy​(String deploymentId)

      Undeploys currently active deployment unit identified by given deploymentId
      Parameters:
        `deploymentId` - unique identifier of the deployment

    - #### undeploy

          void undeploy​(String deploymentId,
                        Function<DeploymentUnit,​Boolean> beforeUndeploy)

      Undeploys currently active deployment unit identified by given deploymentId
      Parameters:
        `deploymentId` - unique identifier of the deployment
        `beforeUndeploy` - a function to run custom actions before undeploying a given `DeploymentUnit`. It should return if the unit can be undeployed or not determining if the deployment can continue.

    - #### activate

          void activate​(String deploymentId)

      Activates given deployment by making sure it will be available for execution.
      Parameters:
        `deploymentId` -

    - #### deactivate

          void deactivate​(String deploymentId)

      Deactivates given deployment by making it only available for already running instances.
      Parameters:
        `deploymentId` -

    - #### isDeployed

          boolean isDeployed​(String deploymentUnitId)

      Performs a check if given deployment is already active
      Parameters:
        `deploymentUnitId` -
      Returns: